package rocks.zipcode;

import java.io.*;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * @author leon on 16/11/2018.
 */
public class Document implements DocumentInterface {

    private final FileWriter fileWriter;
    private final File file;

    public Document(String fileName) throws IOException {
        this(new File(fileName));
    }

    public Document(File file) throws IOException {
        this.file = file;
        this.fileWriter = new FileWriter(file);
    }

    @Override
    public void write(String contentToBeWritten) {

        try(FileWriter fileWriter = new FileWriter("target/file.txt")) {
            //inherited method from java.io.Writer
            fileWriter.write(contentToBeWritten);
            fileWriter.flush();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    @Override
    public void write(Integer lineNumber, String valueToBeWritten) {

        try {
            Path path = Paths.get(file.getPath());
            List<String> list = Files.readAllLines(path);

            String lastLine = list.get(list.size()-1);
            List<String> allButLast = list.subList(0,list.size()-1);
            allButLast.set(lineNumber, valueToBeWritten);
            Files.write(path, allButLast);
            Files.write(path, lastLine.getBytes(), StandardOpenOption.APPEND);

        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    @Override
    public String read(Integer lineNumber) {

        try {
            return new String(String.valueOf(Files.readAllLines(Paths.get(file.getPath())).get(lineNumber)));

        } catch (IOException e) {
            e.printStackTrace();
        }
        return null ;
    }

    @Override
    public String read() {

        try {
            return new String(Files.readAllBytes(Paths.get(file.getPath())));
        }
        catch(IOException e) {
            e.printStackTrace();
        }
        return file.getPath();
    }

    @Override
    public void replaceAll(String stringToReplace, String replacementString) {

        String doc = read();
      doc = doc.replaceAll(stringToReplace, replacementString);
      write(doc);


    }


    @Override
    public void overWrite(String content) {
        write(content);
    }

    public List<String> toList() {
        String[] arr = read().split("\n");
        List<String> result = new ArrayList<>();
        for(String s: arr) {
           result.add(s);
           }
      return result;
    }

    @Override
    public File getFile() {

        return this.file;
    }

    @Override
    public String toString() {
        try {
            Path path = Paths.get(file.getPath());
            List<String> result = Files.readAllLines(path);
            String list = result.toString().replace("[", "").replace("]", "");

            return path +  "{" +list + "}";
        }
        catch(IOException e) {
            e.printStackTrace();
        }
        return null;

    }
}
